import 'package:doctor_app_flutter/config/size_config.dart';
import 'package:doctor_app_flutter/core/viewModel/project_view_model.dart';
import 'package:doctor_app_flutter/models/patient/vital_sign/patient-vital-sign-history.dart';
import 'package:doctor_app_flutter/util/date-utils.dart';
import 'package:doctor_app_flutter/util/translations_delegate_base.dart';
import 'package:doctor_app_flutter/widgets/shared/app_texts_widget.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:provider/provider.dart';

class VitalSignDetailsWidget extends StatefulWidget {
  final List<VitalSignHistory> vitalList;
  final String title1;
  final String title2;
  final String viewKey;

  VitalSignDetailsWidget(
      {Key key, this.vitalList, this.title1, this.title2, this.viewKey});

  @override
  _VitalSignDetailsWidgetState createState() => _VitalSignDetailsWidgetState();
}

class _VitalSignDetailsWidgetState extends State<VitalSignDetailsWidget> {
  @override
  Widget build(BuildContext context) {
    ProjectViewModel projectViewModel = Provider.of(context);
    return Container(
      /*decoration: BoxDecoration(
        color: Colors.transparent,
        borderRadius: BorderRadius.only(
            topLeft: Radius.circular(10.0), topRight: Radius.circular(10.0)),
        border: Border.all(color: Colors.grey, width: 1),
      ),*/
      margin: EdgeInsets.all(0),
      child: Container(
        color: Colors.transparent,
        child: Column(
          crossAxisAlignment: CrossAxisAlignment.start,
          children: <Widget>[
            Row(
              children: [
                Expanded(
                  child: Container(
                    child: Container(
                      padding: EdgeInsets.all(8),
                      /*decoration: BoxDecoration(
            color: Theme.of(context).primaryColor,
            borderRadius: BorderRadius.only(
              topLeft:projectViewModel.isArabic? Radius.circular(0.0):Radius.circular(10.0),
              topRight: projectViewModel.isArabic? Radius.circular(10.0):Radius.circular(0.0)
            ),
          ),*/
                      child: AppText(
                        TranslationBase.of(context).date,
                        fontSize: SizeConfig.textMultiplier * 1.6,
                        fontWeight: FontWeight.bold,

                        fontFamily: 'Poppins',
                      ),
                      // height: 60,
                    ),
                  ),
                ),
                Expanded(
                  child: Container(
                    padding: EdgeInsets.all(8),
                    child: Container(
                      /*decoration: BoxDecoration(
              color: Theme.of(context).primaryColor,
              borderRadius: BorderRadius.only(
                  topRight: projectViewModel.isArabic? Radius.circular(0.0):Radius.circular(10.0),
                  topLeft: projectViewModel.isArabic? Radius.circular(10.0):Radius.circular(0.0)
              ),
            ),*/
                      child: AppText(
                        widget.title2,
                        fontSize: SizeConfig.textMultiplier * 1.6,
                        fontWeight: FontWeight.bold,

                        fontFamily: 'Poppins',
                      ),
                      // height: 60
                    ),
                  ),
                )
              ],
            ),
            const Divider(
              height: 1,
              thickness: 1,
              color: Colors.black,
            ),
            Table(
              border: TableBorder(
                horizontalInside: BorderSide(width: 1.0, color: Colors.grey[300]),
              ),
              children: fullData(projectViewModel),
            ),
          ],
        ),
      ),
    );
  }

  List<TableRow> fullData(ProjectViewModel projectViewModel) {
    List<TableRow> tableRow = [];
    /*  tableRow.add(TableRow(children: [

    ]));*/
    widget.vitalList.forEach((vital) {
      var data = vital.toJson()[widget.viewKey];
      DateTime elementDate =
          DateUtils.getDateTimeFromServerFormat(vital.createdOn);
      if (data != 0)
        tableRow.add(TableRow(children: [
          Container(
            child: Container(
              padding: EdgeInsets.all(8),
              color: Colors.white,
              child: AppText(
                '${projectViewModel.isArabic ? DateUtils.getWeekDayArabic(elementDate.weekday) : DateUtils.getWeekDay(elementDate.weekday)}, ${elementDate.day} ${projectViewModel.isArabic ? DateUtils.getMonthArabic(elementDate.month) : DateUtils.getMonth(elementDate.month)}, ${elementDate.year} ${DateUtils.getHour(elementDate)}',
                // textAlign: TextAlign.center,
                fontSize: SizeConfig.textMultiplier * 1.8,
                fontWeight: FontWeight.w600,

                fontFamily: 'Poppins',
              ),
            ),
          ),
          Container(
            child: Container(
              padding: EdgeInsets.all(8),
              color: Colors.white,
              child: AppText(
                '${vital.toJson()[widget.viewKey]}',
                // textAlign: TextAlign.center,
                fontSize: SizeConfig.textMultiplier * 1.8,
                fontWeight: FontWeight.w600,

                fontFamily: 'Poppins',
              ),
            ),
          ),
        ]));
    });
    return tableRow;
  }
}
